/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Rainer Kartmann ( rainer dot kartmann at kit dot edu )
 * @date       2021
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <QList>
#include <QString>
#include <qhashfunctions.h>
#include <qlist.h>

class QTableWidget;
class QTableWidgetItem;

namespace armarx::navigation::qt_plugins::location_graph_editor::utils
{

    /// <-
    extern const QString arrowLeft;
    /// ->
    extern const QString arrowRight;
    /// <->
    extern const QString arrowBoth;


    enum class EdgeDirection
    {
        From,
        To,
        Bidirectional
    };


    QList<QTableWidgetItem*> getSelectedItemsOfColumn(QTableWidget* widget, int column);

} // namespace armarx::navigation::qt_plugins::location_graph_editor::utils
