#include "TimedElasticBandsParams.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

#include <armarx/navigation/local_planning/core.h>

namespace armarx::navigation::local_planning
{
    // TimedElasticBandsParams

    Algorithms
    TimedElasticBandsParams::algorithm() const
    {
        return Algorithms::TimedElasticBands;
    }

    aron::data::DictPtr
    TimedElasticBandsParams::toAron() const
    {
        return cfg.toAron();
    }

    TimedElasticBandsParams
    TimedElasticBandsParams::FromAron(const aron::data::DictPtr& dict)
    {
        ARMARX_CHECK_NOT_NULL(dict);

        TimedElasticBandsParams bo;
        bo.cfg.fromAron(dict);

        return bo;
    }
} // namespace armarx::navigation::local_planning
