/**
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Reister ( fabian dot reister at kit dot edu )
 * @date       2021
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <mutex>
#include <string>
#include <unordered_map>

#include <ArmarXCore/core/time/DateTime.h>

#include <RobotAPI/libraries/armem/client/util/SimpleWriterBase.h>
#include <RobotAPI/libraries/aron/core/data/variant/forward_declarations.h>

#include <armarx/navigation/core/constants.h>

namespace armarx::navigation::memory::client::param
{

    class Writer : virtual public armem::client::util::SimpleWriterBase
    {
    public:
        using armem::client::util::SimpleWriterBase::SimpleWriterBase;


        bool store(const std::unordered_map<core::StackLayer, aron::data::DictPtr>& stack,
                   const std::string& clientID,
                   const armarx::core::time::DateTime& timestamp);

        std::string propertyPrefix() const override;
        Properties defaultProperties() const override;

    protected:
    private:
        std::mutex writeMutex;
    };

} // namespace armarx::navigation::memory::client::param
