#pragma once

#include <Eigen/Geometry>

#include <armarx/navigation/core/Trajectory.h>
#include <armarx/navigation/core/types.h>
#include <armarx/navigation/server/execution/ExecutorInterface.h>

namespace armarx::navigation::server
{

    /**
     * @brief Executor that doesn't do anything. Each method is empty.
     * 
     */
    class DummyExecutor : virtual public ExecutorInterface
    {

    public:
        DummyExecutor() = default;

        ~DummyExecutor() override = default;


        void execute(const core::LocalTrajectory& trajectory,
                     bool activateController = false) override;

        void execute(const core::GlobalTrajectory& trajectory,
                     bool activateController = false) override;

        void start(ControllerType controllerType) override;
        void stop() override;

        void ensureIsActive(ControllerType controllerType) override;

        void updateVelocityLimits(const core::TwistLimits& limits) override;
    };

} // namespace armarx::navigation::server
