#pragma once

#include <string>

#include <RobotAPI/libraries/armem/client/MemoryNameSystem.h>
#include <RobotAPI/libraries/armem_robot_state/client/common/VirtualRobotReader.h>
#include <RobotAPI/libraries/skills/core/SkillDescription.h>

#include <armarx/navigation/client/services/IceNavigator.h>
#include <armarx/navigation/skills/NavigateRelativeSkill.h>
#include <armarx/navigation/skills/aron/MoveRelativePlanar.aron.generated.h>

namespace armarx::navigation::skills
{

    class MoveRelativePlanar : public NavigateRelativeSkill<arondto::MoveRelativePlanarParams>
    {

    public:
        using Base = NavigateRelativeSkill<arondto::MoveRelativePlanarParams>;

        struct Services
        {
            client::IceNavigator& iceNavigator;
            armem::client::MemoryNameSystem& memoryNameSystem;
            armem::robot_state::VirtualRobotReader& robotReader;
        };

        struct Properties
        {
            std::string robotName;
        };

        MoveRelativePlanar(const Properties& properties, const Services& srv);

    private:
        Eigen::Isometry3f relativeTarget(const Base::SpecializedMainInput& in) override;


    public:
        static armarx::skills::SkillDescription DefaultSkillDescription();

    private:
        Properties properties;

        struct MyServices
        {
            armem::robot_state::VirtualRobotReader& robotReader;
        };

        MyServices services;
    };

} // namespace armarx::navigation::skills
