/**
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Reister ( fabian dot reister at kit dot edu )
 * @date       2023
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <string>

namespace armarx::navigation::skills::constants
{
    inline const std::string NavigationSkillProviderName = "navigation_skill_provider";
}

namespace armarx::navigation::skills::constants::skill_names
{

    inline const std::string BringHumanIntoRoom = "BringHumanIntoRoom";
    inline const std::string GuideHumanToRoom = "GuideHumanToRoom";
    inline const std::string MoveRelativePlanar = "MoveRelativePlanar";
    inline const std::string MoveXMeters = "MoveXMeters";
    inline const std::string NavigateTo = "NavigateTo";
    inline const std::string NavigateToLocation = "NavigateToLocation";
    inline const std::string NavigateToNamedLocation = "NavigateToNamedLocation";
    inline const std::string NavigateToChargingStation = "NavigateToChargingStation";
    inline const std::string ResolveLocationName = "ResolveLocationName";
    inline const std::string RotateXDegrees = "RotateXDegrees";

} // namespace armarx::navigation::skills::constants::skill_names
