/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Rainer Kartmann ( rainer dot kartmann at kit dot edu )
 * @date       2023
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */


#include "skill_ids.h"

#include <RobotAPI/libraries/skills/core/ProviderID.h>
#include <RobotAPI/libraries/skills/core/SkillID.h>

#include <armarx/navigation/skills/constants.h>

namespace armarx::navigation::skills
{
    const armarx::skills::ProviderID skill_ids::SkillProviderID{
        .providerName = constants::NavigationSkillProviderName,
    };

    const armarx::skills::SkillID skill_ids::BringHumanIntoRoom{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::BringHumanIntoRoom,
    };

    const armarx::skills::SkillID skill_ids::GuideHumanToRoom{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::GuideHumanToRoom,
    };

    const armarx::skills::SkillID skill_ids::MoveRelativePlanar{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::MoveRelativePlanar,
    };

    const armarx::skills::SkillID skill_ids::MoveXMeters{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::MoveXMeters,
    };

    const armarx::skills::SkillID skill_ids::NavigateTo{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::NavigateTo,
    };

    const armarx::skills::SkillID skill_ids::NavigateToLocation{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::NavigateToLocation,
    };

    const armarx::skills::SkillID skill_ids::NavigateToNamedLocation{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::NavigateToNamedLocation,
    };

    const armarx::skills::SkillID skill_ids::NavigateToChargingStation{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::NavigateToChargingStation,
    };

    const armarx::skills::SkillID skill_ids::RotateXDegrees{
        .providerId = SkillProviderID,
        .skillName = constants::skill_names::RotateXDegrees,
    };

} // namespace armarx::navigation::skills
