/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Rainer Kartmann ( rainer dot kartmann at kit dot edu )
 * @date       2023
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <RobotAPI/libraries/skills/core/ProviderID.h>
#include <RobotAPI/libraries/skills/core/SkillID.h>

namespace armarx::navigation::skills::skill_ids
{
    extern const armarx::skills::ProviderID SkillProviderID;

    extern const armarx::skills::SkillID BringHumanIntoRoom;
    extern const armarx::skills::SkillID GuideHumanToRoom;
    extern const armarx::skills::SkillID MoveRelativePlanar;
    extern const armarx::skills::SkillID MoveXMeters;
    extern const armarx::skills::SkillID NavigateTo;
    extern const armarx::skills::SkillID NavigateToLocation;
    extern const armarx::skills::SkillID NavigateToNamedLocation;
    extern const armarx::skills::SkillID NavigateToChargingStation;
    extern const armarx::skills::SkillID RotateXDegrees;

} // namespace armarx::navigation::skills::skill_ids
