/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    navigation::NavigationCommands::NavigationCommandsRemoteStateOfferer
 * @author     Fabian Reister ( fabian dot reister at kit dot edu )
 * @date       2022
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#include "NavigationCommandsRemoteStateOfferer.h"

namespace armarx::navigation::statecharts::navigation_commands
{
    // DO NOT EDIT NEXT LINE
    NavigationCommandsRemoteStateOfferer::SubClassRegistry
        NavigationCommandsRemoteStateOfferer::Registry(
            NavigationCommandsRemoteStateOfferer::GetName(),
            &NavigationCommandsRemoteStateOfferer::CreateInstance);

    NavigationCommandsRemoteStateOfferer::NavigationCommandsRemoteStateOfferer(
        StatechartGroupXmlReaderPtr reader) :
        XMLRemoteStateOfferer<NavigationCommandsStatechartContext>(reader)
    {
    }

    void
    NavigationCommandsRemoteStateOfferer::onInitXMLRemoteStateOfferer()
    {
    }

    void
    NavigationCommandsRemoteStateOfferer::onConnectXMLRemoteStateOfferer()
    {
    }

    void
    NavigationCommandsRemoteStateOfferer::onExitXMLRemoteStateOfferer()
    {
    }

    // DO NOT EDIT NEXT FUNCTION
    std::string
    NavigationCommandsRemoteStateOfferer::GetName()
    {
        return "NavigationCommandsRemoteStateOfferer";
    }

    // DO NOT EDIT NEXT FUNCTION
    XMLStateOffererFactoryBasePtr
    NavigationCommandsRemoteStateOfferer::CreateInstance(StatechartGroupXmlReaderPtr reader)
    {
        return XMLStateOffererFactoryBasePtr(new NavigationCommandsRemoteStateOfferer(reader));
    }
} // namespace armarx::navigation::statecharts::navigation_commands
